;
;                          
;                                
;                                      
;                              
;                      v2.0
;            The Custom Menu Customizer by Sam Davies
;                    sdavies@mail.trilogy.net
;
;To reduce the size of the appended code, simply change the value for
;NUM_SLOTS (must be from 1 to 14), and recompile.
;
NUM_SLOTS = 1
;


#if (NUM_SLOTS > 14)
!!!Error: NUM_SLOTS must be <=14
#endif
#if (NUM_SLOTS < 1)
!!!Error: NUM_SLOTS must be >=1
#endif

#include "usgard.h"

CUR_SEL = TEXT_MEM + 20
.org 0
Title:
.db "CustCust v2.0 by SD",0

Ask:
        ld      HL, (PROGRAM_ADDR)
        call    &RedrawStatus
	ld	HL, (PROGRAM_ADDR)
	call    CHECK_APPEND
        jp      z, &Install
        ld      BC, ID_STR_BEGIN-APPEND_CODE
        add     HL, BC
        ld      (&IDSB_POS), HL

Wkey_redraw:
        call    &RedrawWin

Wkeyloop:
        call    GET_KEY
        and     A
        jr      z, Wkeyloop
        cp      K_UP
        jr      z, Slot_UP
        cp      K_DOWN
        jr      z, Slot_DOWN
        cp      K_LEFT
        jr      z, Slot_LEFT
        cp      K_RIGHT
        jr      z, Slot_RIGHT
        cp      K_CLEAR
        jr      z, Slot_CLEAR
        cp      K_DEL
        jr      z, Slot_CLEAR
        cp      K_ENTER
        jr      z, Slot_Selected
        cp      K_EXIT
        ret     z
        jr      Wkeyloop

Slot_UP:
        call    &Select
        ld      A, (CUR_SEL)
        or      A
        jr      z, SetNUM
        dec     A
Continue_NUM:
        ld      (CUR_SEL), A
        call    &Select
        jr      Wkeyloop
SetNUM:
        ld      A, NUM_SLOTS
        jr      Continue_NUM
Slot_DOWN:
        call    &Select
        ld      A, (CUR_SEL)
        cp      NUM_SLOTS
        jr      z, SetOne
        inc     A
Continue_Set:
        ld      (CUR_SEL), A
        call    &Select
        jr      Wkeyloop

SetOne
        xor     A
        jr      Continue_Set

Slot_LEFT:
        ld      A, (CUR_SEL)
        or      A
        jr      z, Wkeyloop
        sub     7
        jr      c, Wkeyloop
        push    AF
        call    &Select
        pop     AF
        ld      (CUR_SEL), A
        call    &Select
        jr      Wkeyloop
Slot_RIGHT:
        ld      A, (CUR_SEL)
        or      A
        jr      z, Wkeyloop
        cp      8
        jr      nc, Wkeyloop
        push    AF
        call    &Select
        pop     AF
        add     A, 7
        cp      NUM_SLOTS+1
        jr      c, no_set_max
        ld      A, NUM_SLOTS
no_set_max:
        ld      (CUR_SEL), A
        call    &Select
        jp      &Wkeyloop

Slot_CLEAR:
        ld      A, (CUR_SEL)
        or      A
        jp      z, &Wkeyloop
        dec     A
        sla     A
        ld      E, A
        ld      D, 0
        ld      HL, $8BB5
        add     HL, DE
        ld      (HL), D
        inc     HL
        ld      (HL), D
        jp      &Wkey_redraw


Slot_Selected:
        ld      A, (CUR_SEL)
        or      A
        jp      z, &Uninstall

        call    &Restart
        push    HL

        ld      A, (CUR_SEL)
        dec     A
        ld      L, A
        ld      H, 9
        call    MUL_HL
        ex      DE, HL
        ld      HL, (&IDSB_POS)
        ld      BC, StringNames-ID_STR_BEGIN
        add     HL, BC
        add     HL, DE
        ex      DE, HL
        pop     HL
        ld      BC, 9
        ldir

        ld      A, (CUR_SEL)
        dec     A
        ld      HL, &Addresses
        add     A, A
        ld      C, A
        ld      B, 0
        add     HL, BC
        call    LD_HL_MHL
        ld      DE, (&IDSB_POS)
        add     HL, DE
        push    HL
        ex      DE, HL

        ld      HL, $8BB5
        add     HL, BC
        ld      (HL), E
        inc     HL
        ld      (HL), D

        pop     IX
        ld      BC, 6
        add     IX, BC
        push    IX

        ld      HL, &Abbrev
        call    &RedrawStatus
        ld      A, 00010000b
        ld      HL, $0001
        ld      (CURSOR_ROW), HL
        ld      C, 5
        ld      A, 00010000b
        call    &INPST

        pop     IX
        ld      A, (IX)
        and     A
        ret     nz
        ld      (IX), $20
        ld      (IX+1), 0
        ret


Install:
        ld      HL, &APPEND_CODE
        ld      BC, APPEND_CODE_END-APPEND_CODE
	ld	DE, (PROGRAM_ADDR)
	call    APPEND
        jr      c, Error
        ld      D, H
        ld      E, L
	ld      BC, StringNames-APPEND_CODE
        add     HL, BC
        ex      DE, HL
	ld      BC, (ID_STR_BEGIN-2)-APPEND_CODE
        add     HL, BC
        ld      (HL), E
        inc     HL
        ld      (HL), D

        ld      HL, $0001
        ld      (CURSOR_ROW), HL
        ld      HL, &Installed
        call    D_ZT_STR
        call    OTH_PAUSE
        jp      &Ask

Error:
        ld      HL, $0001
        ld      (CURSOR_ROW), HL
        ld      HL, &Note
	call    D_ZT_STR
        call    OTH_PAUSE
        ret

Uninstall:
	ld	HL, (PROGRAM_ADDR)
        push    HL
	call    CHECK_APPEND
        pop     HL
        jr      nc, TSRs
	call    UNAPPEND
        ld      HL, $8BB5
        ld      DE, $8BB6
        ld      (HL), 0
        ld      BC, NUM_SLOTS*2-1
        ldir
        ld      HL, (PROGRAM_ADDR)
        call    &RedrawStatus
        ld      HL, $0001
        ld      (CURSOR_ROW), HL
        ld      HL, &Removed
        call    D_ZT_STR
        call    OTH_PAUSE
        ret

TSRs:
        call    &RedrawStatus
        ld      HL, $0001
        ld      (CURSOR_ROW), HL
        ld      HL, &RemoveApp
        call    D_ZT_STR
        call    OTH_PAUSE
        ret        

RedrawStatus:
        push    HL
        call    CLEARLCD
	inc	E
	ld      (CURSOR_X), DE
	pop     HL
	call    D_ZM_STR
	ld      HL, VIDEO_MEM
	ld      B, 16*7
InvLoop:
	ld      A, (HL)
	cpl
	ld      (HL), A
	inc     HL
	djnz    InvLoop
	ret

RedrawWin:
	ld      HL, $8BB5
        ld      IX, &Menu_Start+3
        ld      B, NUM_SLOTS
NextLine:
	push    BC
        ld      E, (HL)
        inc     HL
        ld      D, (HL)
        inc     HL
        ld      A, E
        or      D
        jr      z, setEMPTY
        inc     DE
        inc     DE
        inc     DE
        inc     DE
        inc     DE
        inc     DE
        jr      notEMPTY
setEMPTY:
        ld      DE, &EMPTY
notEMPTY:
        ld      B, 6
CopyLoop:
        ld      A, (DE)
        and     A
        jr      z, ZeroFound
        ld      (IX), A
        inc     IX
        inc     DE
        djnz    CopyLoop
Continue:
        ld      BC, 4
        add     IX, BC
        pop     BC
        djnz    NextLine

        ld      HL, (PROGRAM_ADDR)
        call    &RedrawStatus

        ld      DE, $0700
        ld      HL, &Contents
#if NUM_SLOTS<=7
        ld      B, NUM_SLOTS+1
#else
        ld      B, 8
#endif
PrintLoop:
        ld      (CURSOR_X), DE
        call    D_ZM_STR
        ld      A, 7
        add     A, D
        ld      D, A
        djnz    PrintLoop
#if NUM_SLOTS>7
        ld      DE, $0E40
        ld      B, NUM_SLOTS-7
PrintLoop2:
        ld      (CURSOR_X), DE
        call    D_ZM_STR
        ld      A, 7
        add     A, D
        ld      D, A
        djnz    PrintLoop2
#endif
        ld      A, (CUR_SEL)
        ld      D, A
        call    &Select
        ret

ZeroFound:
        ld      A, $20
CopyAgain:
        ld      (IX), A
        inc     IX
        djnz    CopyAgain
        jr      Continue

Select:
        ld      A, (CUR_SEL)
        or      A
        jr      z, UI_Selected
        cp      8
        jr      nc, Col2
        ld      BC, VIDEO_MEM + (7*16)
        jr      Col1
Col2:
        ld      BC, VIDEO_MEM + (7*16) + 8
        sub     7
Col1:
        ld      E, A
        ld      D, 0
        ld      L, E
        ld      H, D
        add     HL, HL
        ex      DE, HL
        add     HL, DE
        ex      DE, HL
        add     HL, HL
        ex      DE, HL
        add     HL, DE
        add     HL, HL
        add     HL, HL
        add     HL, HL
        add     HL, HL ;Current selection * 7*16

        add     HL, BC
        ld      C, 7
        ld      DE, 8
InvLoop1:
        ld      B, 8
InvLoop_1:
        ld      A, (HL)
        cpl
        ld      (HL), A
        inc     HL
        djnz    InvLoop_1
        add     HL, DE
        dec     C
        jr      nz, InvLoop1
        ret

UI_Selected:
        ld      HL, VIDEO_MEM+(16*7)
        ld      B, 16*7
InvLoop_U:
        ld      A, (HL)
        cpl
        ld      (HL), A
        inc     HL
        djnz    InvLoop_U
        ret

IDSB_POS:
.dw 0

EMPTY:
.db "EMPTY",0
Contents:
.db "Uninstall",0
Menu_Start:
.db "2  NOT WR",0
#if (NUM_SLOTS>=2)
.db "3  NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=3)
.db "4  NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=4)
.db "5  NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=5)
.db "6  NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=6)
.db "7  NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=7)
.db "8  NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=8)
.db "9  NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=9)
.db "10 NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=10)
.db "11 NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=11)
.db "12 NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=12)
.db "13 NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS>=13)
.db "14 NOT WR",0
#else
.db 0
#endif
#if (NUM_SLOTS=14)
.db "15 NOT WR",0
#endif

Addresses:
#if (NUM_SLOTS>=1)
.dw SLOT_2-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=2)
.dw SLOT_3-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=3)
.dw SLOT_4-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=4)
.dw SLOT_5-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=5)
.dw SLOT_6-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=6)
.dw SLOT_7-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=7)
.dw SLOT_8-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=8)
.dw SLOT_9-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=9)
.dw SLOT_10-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=10)
.dw SLOT_11-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=11)
.dw SLOT_12-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=12)
.dw SLOT_13-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=13)
.dw SLOT_14-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=14)
.dw SLOT_15-ID_STR_BEGIN
#endif

Choose:
.db "Choose A File:",0
;EnterName:
;.db "Name",0
NONAME:
.db "NoName",0
Note:
.db "Failure.",0
Removed:
.db "Removed.",0
Abbrev:
.db "Enter Abbreviation:",0
RemoveApp:
.db "Remove other appended"
.db "code.",0
Installed:
.db "Installed",0

APPEND_CODE:

#if (NUM_SLOTS>=14)
SLOT_15:
        .db $41,$00,$07
        xor     A
        jr      C_15
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=13)
SLOT_14:
        .db $41,$00,$07
        xor     A
        jr      C_14
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=12)
SLOT_13:
        .db $41,$00,$07
        xor     A
        jr      C_13
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=11)
SLOT_12:
        .db $41,$00,$07
        xor     A
        jr      C_12
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=10)
SLOT_11:
        .db $41,$00,$07
        xor     A
        jr      C_11
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=9)
SLOT_10:
        .db $41,$00,$07
        xor     A
        jr      C_10
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=8)
SLOT_9:
        .db $41,$00,$07
        xor     A
        jr      C_9
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=7)
SLOT_8:
        .db $41,$00,$07
        xor     A
        jr      C_8
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=6)
SLOT_7:
        .db $41,$00,$07
        xor     A
        jr      C_7
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=5)
SLOT_6:
        .db $41,$00,$07
        xor     A
        jr      C_6
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=14)
C_15:   inc     A
#endif
#if (NUM_SLOTS>=13)
C_14:   inc     A
#endif
#if (NUM_SLOTS>=12)
C_13:   inc     A
#endif
#if (NUM_SLOTS>=11)
C_12:   inc     A
#endif
#if (NUM_SLOTS>=10)
C_11:   inc     A
#endif
#if (NUM_SLOTS>=9)
C_10:   inc     A
#endif
#if (NUM_SLOTS>=8)
C_9:    inc     A
#endif
#if (NUM_SLOTS>=7)
C_8:    inc     A
#endif
#if (NUM_SLOTS>=6)
C_7:    inc     A
#endif
#if (NUM_SLOTS>=5)
C_6:    inc     A
#endif
#if (NUM_SLOTS>=4)
C_5:    inc     A
#endif
#if (NUM_SLOTS>=3)
C_4:    inc     A
#endif
#if (NUM_SLOTS>=2)
C_3:    inc     A
#endif
C_2:

Exec:
        call    BUSY_OFF

        ld      DE, StringNames
ID_STR_BEGIN:
        ld      L, A
        ld      H, 9
        push    DE
        call    MUL_HL
        pop     DE
        add     HL, DE
        call    VAR_EXEC
        call    CLEARTEXT
        jp      462h
ID_STR_END:

#if (NUM_SLOTS>=4)
SLOT_5:
        .db $41,$00,$07
        xor     A
        jr      C_5
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=3)
SLOT_4:
        .db $41,$00,$07
        xor     A
        jr      C_4
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=2)
SLOT_3:
        .db $41,$00,$07
        xor     A
        jr      C_3
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=1)
SLOT_2:
        .db $41,$00,$07
        xor     A
        jr      C_2
        .db 0,0,0,0,0,0,0
#endif

StringNames:

#if (NUM_SLOTS>=14)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=13)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=12)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=11)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=10)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=9)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=8)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=7)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=6)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=5)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=4)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=3)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=2)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=1)
.db 0,0,0,0,0,0,0,0,0
#endif
APPEND_CODE_END:


INPST:
 ld	hl, $8358
 or	(hl)
 ld	(hl), a

INPST_clear:
 push   ix
 ld     b, 0                    ;I chose B as counter
 set	2, (iy+12)

INPST_key:
 ld	a, ' '
 ld	($800E), a
 call   GET_KEY
 cp     9
 jr     c, INPST_key
 cp     K_EXIT
 jr     z, INPST_Exit1
 cp     K_ENTER
 jr     z, INPST_Exit
 cp     K_ALPHA
 jp     z, &INPST_change
 cp     K_CLEAR
 jr     z, INPST_bclear
 cp     K_DEL
 jr     nz, CheckOther
 call   &INPST_delete
 jr     INPST_key
CheckOther:
 cp     $2F
 jr     nc, INPST_key
 sub    10
 push   af
 ld     a, b
 cp     c
 jr     nz, INPST_checkcase
 pop    af
 jr     INPST_key
INPST_bclear:
INPST_bclear1:
 call   &INPST_delete
 jr	nz, INPST_bclear1
 jr     INPST_key
INPST_Exit:
 ld     (ix), 0
 pop    ix
 jr	INPST_Exitr
INPST_Exit1:
 pop    ix
 ld     (ix), 0
INPST_Exitr:
 res	2, (iy+12)
 ret

INPST_checkcase:
 ld	de, &number
 bit	4, (iy+$12)
 jr	z, INPST_gotcase
 ld	de, &upper
INPST_gotcase:
 pop    af
 ld     l, a
 ld     h, 0
 add    hl, de
 ld     a, (hl)
 or     a
 jr     z, INPST_key
 bit	5, (iy+$12)
 jr	z, SetChar
 cp	' '
 jr	z, SetChar
 add	a, 32
SetChar:
 ld     (ix), a
 inc    ix
 call   TX_CHARPUT
 inc    b
 jr     INPST_key

INPST_delete:
 dec	b
 inc	b
 ret	z
 ld	(ix), 0
 dec	ix
 ld	a, ' '
 call	TX_CHARPUT
; call	TX_CHARPUT
 ld	hl, CURSOR_COL
; dec	(hl)
 dec	(hl)
 dec	(hl)
 dec	b
 ret

INPST_change:
 ld	a, ($8358)
 bit	4, a
 jr	z, SetALPHAB	;Number -> ALPHA
 bit	5, a
 jr	z, SetalphaB	;ALPHA -> alpha
 and	11001111b
 jr	SetCase
SetalphaB:
 set	5, a
 jr	SetCase
SetALPHAB:
 set    4, a
SetCase:
 ld	($8358), a
 jp	&INPST_key

upper:
.db 'X','T','O','J','E',0
.db 0,' ','W','S','N','I'
.db 'D',0,0,'Z','V','R','M'
.db 'H','C',0,0,'Y','U','Q'
.db 'L','G','B',0,0,0,'='
.db 'P','K','F','A'             ;= 37 bytes

;lower:
;.db 'x','t'
;.db 'o','j','e',0,0,' ','w'
;.db 's','n','i','d',0,0,'z'
;.db 'v','r','m','h','c',0,0
;.db 'y','u','q','l','g','b'
;.db 0,0,0,'=','p','k','f','a'   ;= 37 bytes

number:
.db '+','-','*','/','^','!'
.db 0,'~','3','6','9',')','?'
.db 0,0,'.','2','5','8','(','`'
.db 0,0,'0','1','4','7','>',':'
.db 0,0,0,'$',',','%','<','#'   ;= 37 bytes


#DEFINE UsgStart $8BF9

UsgLength = $8BF7
noStr	  = $80DF
curVAT	  = $80E0
firstpg   = $80E2
curStr	  = $80E3
proglist  = $8100


Restart:
        ld      HL, &Choose
        call    &RedrawStatus
RestartVAT:
 ld hl,VAT_START-10    ; Skip the first entry, the Usgard string itself
 ld (curVAT),hl
 xor a
 ld (firstpg),a
ScanStrings:
 xor a
 ld (noStr),a
 ld hl,$0801
 ld ($8333),hl
 ld hl,$FC80
 ld bc,911
 call OTH_CLEAR
 ld hl,(curVAT)
 ld ix,proglist
Search:
 ld a,$0C
 call SEARCH_VAT
 jr c,EndOfVAT
 push hl
 ld a,(de)
 or a
 jr nz,NoAsmProg
 inc de
 ld a,(de)
 cp PROG_HEADER
 jr c,NoAsmProg
 inc de
 inc de
; ld hl,(PROGRAM_ADDR)
; call CP_HL_DE         ; Check if the program found it the shell
; jr z,NoAsmProg
 push de
 ld hl,noStr
 inc (hl)
 ld hl,VATName
 push hl
 push ix
 pop de
 ld bc,9
 ldir
 push de
 pop ix
 pop hl
 call D_ZM_STR
 ld a,$24
 ld ($8333),a
 pop hl
 call D_ZM_STR
 ld hl,$8333
 ld (hl),1
 inc hl
 ld a,(hl)
 add a,7
 ld (hl),a
NoAsmProg:
 pop hl
 ld a,(noStr)
 cp 8
 jr nz,Search
EndOfVAT:
 ld (curVAT),hl
 ld hl,firstpg
 ld b,(hl)
 inc (hl)
 ld a,(noStr)
 or a
 jr nz,SelectProgram
 or b
 jp nz,&RestartVAT
 ld hl,&NoProgsTxt
 call D_ZM_STR
 call OTH_PAUSE
 ret
SelectProgram:
 xor a
Update:
 ld (curStr),a
Update2:
 call &InvertCurrent
 ld a,(noStr)
 ld c,a
WaitKey:
 ld (iy+8),$8C
 call GET_KEY
 or a
 jr z,WaitKey
 call UPDATE_APD
 ld (iy+8),$84
 cp K_MORE
 jp z,&ScanStrings
; cp K_EXIT
; ret z
 cp K_ENTER
 jr z,ExecuteProgram
 ld hl,curStr
 dec a
 jr z,CursorDown
 cp 3
 jr nz,WaitKey
 call &InvertCurrent
 ld a,(hl)
 dec (hl)
 or a
 jr nz,Update2
 ld a,c
 dec a
 jr Update
CursorDown:
 call &InvertCurrent
 ld a,(hl)
 inc a
 cp c
 jr nz,Update
 jr SelectProgram
ExecuteProgram:
 ld a,(curStr)
 ld h,9
 ld l,a
 call MUL_HL
 ld de,proglist
 add hl,de
 ret

InvertCurrent:
 push hl
 ld a,(curStr)
 ld h,112
 ld l,a
 call MUL_HL
 ld de,$FC80
 add hl,de
 ld b,112
Invert:
 ld a,(hl)
 cpl
 ld (hl),a
 inc hl
 djnz Invert
 pop hl
 ret


ShellName:
 .db "usgdsimp",0

NoProgsTxt:
 .db "No programs",0



.end
        
